'-----------------------------------------------------------------------------------
' The program prepare a Console Screen into an area and than Write it to the console
' screen.   Simplified version.
' Generalized SetAttribute()/PrepareAttribute() SUB.
'-----------------------------------------------------------------------------------
' 03 September 2010    -     Version 0.3
'-----------------------------------------------------------------------------------

#COMPILE EXE
#OPTIMIZE SIZE
#DIM ALL
#REGISTER NONE

#INCLUDE "win32api.inc"


DECLARE SUB BoxDraw (BYVAL r1%, BYVAL c1%, BYVAL r2%, BYVAL c2%,_
                     BYVAL PtrBuf AS STRING PTR)

DECLARE SUB DisplayArea (BYVAL r1%, BYVAL c1%, BYVAL r2%, BYVAL c2%,_
                         BYVAL PtrBuf AS STRING PTR)

DECLARE SUB DisplayLine (BYVAL r1%, BYVAL c1%,BYVAL PtrText AS STRING PTR,_
                         BYVAL TextColor AS BYTE, BYVAL TextLenght AS LONG,_
                         BYVAL PtrBuf AS STRING PTR)

DECLARE SUB SetAttribute (BYVAL ColorToSet AS BYTE, BYVAL PtrBuf AS STRING PTR)


DECLARE SUB PrepareAttribute (BYVAL InkColor AS BYTE, BYVAL BackColor AS BYTE)

DECLARE SUB DisplaySequence


'-----------------------------------------------------------------------------------

FUNCTION PBMAIN () AS LONG


   GLOBAL TextColor AS BYTE, ColorToSet AS BYTE
   GLOBAL ScreenBuffer AS STRING
   GLOBAL PtrBuf AS STRING PTR, PtrText AS STRING PTR
   GLOBAL OutHandle AS LONG

   GLOBAL Yellow AS BYTE, Blue AS BYTE
   GLOBAL BrightWhite AS BYTE, Magenta AS BYTE
   GLOBAL InkColor AS BYTE, BackColor AS BYTE
   GLOBAL TextToDisplay AS STRING, TextLenght AS LONG

'-----------------------------------------------------------------------------------
' Here we prepare a line of text to display with its attributes
'-----------------------------------------------------------------------------------
   TextToDisplay = "     Valori dei caratteri visualizzabili - Codici ASCII.     "
   PtrText = STRPTR(TextToDisplay)
   TextLenght = LEN(TextToDisplay)

   ScreenBuffer = SPACE$(8000)

   PtrBuf =  STRPTR(ScreenBuffer)

   Yellow = 14
   Blue   = 1

   InkColor = Yellow
   BackColor = Blue


'-----------------------------------------------------------------------------------
' Set the main attribute for the entire Screen Buffer to display
'-----------------------------------------------------------------------------------

   CALL PrepareAttribute ( InkColor, BackColor)

   !mov ColorToSet, al

   CALL SetAttribute ( ColorToSet, PtrBuf )


   BrightWhite = 15
   Magenta = 5

'-----------------------------------------------------------------------------------

   CONSOLE SET SCREEN 25,80

   CURSOR OFF

   OutHandle = GETSTDOUT

   CALL BoxDraw ( 1, 1, 3, 80, PtrBuf)

   CALL BoxDraw ( 4, 1, 25, 80, PtrBuf)

   InkColor = BrightWhite
   BackColor = Magenta

   CALL PrepareAttribute ( InkColor, BackColor)

   !mov TextColor, al

   CALL DisplayLine ( 2, 11, PtrText, TextColor, TextLenght, PtrBuf)

   CALL DisplaySequence

   CALL DisplayArea ( 1, 1, 25, 80, BYVAL PtrBuf)


   WAITKEY$

'------------------------------------------------------------------------
' We check the Ret Code of WriteConsoleOutput API
'------------------------------------------------------------------------
'
'
'   CLS
'
'   LOCATE 12,20
'   IF RetValue <> 0 THEN
'      PRINT "WriteConsoleOutput was successful - Press a Key"
'   ELSE
'      PRINT "Error WriteConsoleOutput - Press a Key"
'   END IF
'
'   WAITKEY$
'------------------------------------------------------------------------

END FUNCTION


'-----------------------------------------------------------------------------------
' Display any area up to full screen
'-----------------------------------------------------------------------------------
SUB DisplayArea (BYVAL r1%, BYVAL c1%, BYVAL r2%, BYVAL c2%,_
                 BYVAL PtrBuf AS STRING PTR)

    LOCAL SizeOfBuf AS DWORD
    LOCAL Rectangl AS SMALL_RECT
    SizeOfBuf = MAKDWD(c2%+1-c1%, r2%+1-r1%)    ' Size of rectangle
    Rectangl.xTop = r1%-1                       ' Set Row and column
    Rectangl.xLeft = c1%-1                      ' address of all 4 sides
    Rectangl.xBottom = r2%-1                    ' of a Rectangle for Read
    Rectangl.xRight = c2%-1                     ' or for Write.

    WriteConsoleOutput OutHandle, BYVAL PtrBuf, BYVAL SizeOfBuf, 0&, Rectangl

'--------------------------------------------------------------------------------
' Verify return code of WriteConsoleOutput in eax.
'--------------------------------------------------------------------------------

'    !mov RetValue, eax

END SUB


'--------------------------------------------------------------------------------
' We prepare a Box into a string variable Buffer 8000 bytes long
'--------------------------------------------------------------------------------

SUB BoxDraw (BYVAL r1%, BYVAL c1%, BYVAL r2%, BYVAL c2%,_
             BYVAL PtrBuf AS STRING PTR)


    LOCAL  StartPoint AS LONG, Counter AS LONG
    LOCAL  PtrBuf2 AS STRING PTR, LineChars AS LONG, LinesNumber AS LONG

    STATIC TopLeft AS BYTE
    STATIC TopRight AS BYTE
    STATIC BottomLeft AS BYTE
    STATIC BottomRight AS BYTE
    STATIC HorizLine AS BYTE
    STATIC VerticLine AS BYTE

'----------------------------------------------------------------------------------
' ASCII Chars to build Boxes
'----------------------------------------------------------------------------------

    TopLeft  = 218

    TopRight = 191

    BottomLeft = 192

    BottomRight = 217

    HorizLine = 196

    VerticLine = 179


    PtrBuf2 = PtrBuf


'----------------------------------------------------------------------------------
' Start Point into the Buffer to start filling bytes
'----------------------------------------------------------------------------------

    StartPoint = ((r1% - 1) * 80 * 4)

'----------------------------------------------------------------------------------
' Fill the Box area with the requested characters for the Box
'----------------------------------------------------------------------------------
    PtrBuf2 = PtrBuf
    PtrBuf2 = PtrBuf2 + StartPoint

    POKE PtrBuf2, TopLeft

    PtrBuf2 = PtrBuf2 + 4

    LineChars = c2% - c1% - 1

    FOR Counter = 1 TO LineChars

        POKE PtrBuf2, HorizLine
        PtrBuf2 = PtrBuf2 +  4

    NEXT Counter

    POKE PtrBuf2, TopRight
    PtrBuf2 = PtrBuf2 +  4

    LinesNumber = r2% - r1% - 1

    FOR Counter = 1 TO LinesNumber

        POKE PtrBuf2, VerticLine
        PtrBuf2 = PtrBuf2 +  ( 4 * LineChars ) + 4
        POKE PtrBuf2, VerticLine
        PtrBuf2 = PtrBuf2 + 4


    NEXT Counter

    POKE PtrBuf2, BottomLeft

    PtrBuf2 = PtrBuf2 + 4

    FOR Counter = 1 TO LineChars

        POKE PtrBuf2, HorizLine
        PtrBuf2 = PtrBuf2 +  4

    NEXT Counter

    POKE PtrBuf2, BottomRight




END SUB



'--------------------------------------------------------------------------------
' We prepare a Line of Text into a string variable Buffer 8000 bytes long
'--------------------------------------------------------------------------------

SUB DisplayLine (BYVAL r1%, BYVAL c1%,BYVAL PtrText AS STRING PTR,_
                 BYVAL TextColor AS BYTE, BYVAL NumberOfChars AS LONG,_
                 BYVAL PtrBuf AS STRING PTR )


    LOCAL  StartPoint AS LONG, Counter AS LONG
    LOCAL  PtrBuf2 AS STRING PTR, LineChars AS LONG

'----------------------------------------------------------------------------------
' Start Point inside the buffer to put the string data
'----------------------------------------------------------------------------------

    StartPoint = ((r1% - 1) * 80 * 4) + ((c1% - 1) * 4 )
    PtrBuf2 = PtrBuf


'----------------------------------------------------------------------------------
' Fill the Line area with the requested attributes
'----------------------------------------------------------------------------------
    PtrBuf2 = PtrBuf2 + StartPoint
    PtrBuf2 = PtrBuf2 + 2

    FOR Counter = 1 TO NumberOfChars

        POKE PtrBuf2, TextColor
        PtrBuf2 = PtrBuf2 +  4

    NEXT Counter

'----------------------------------------------------------------------------------
' Fill the Line area with the requested Characters
'----------------------------------------------------------------------------------
    PtrBuf2 = PtrBuf + StartPoint

    FOR Counter = 1 TO NumberOfChars

        POKE PtrBuf2, PEEK (PtrText + Counter - 1)
        PtrBuf2 = PtrBuf2 +  4

    NEXT Counter

END SUB


'----------------------------------------------------------------------------------
' Fill the Entire Screen Buffer with the requested Attribute
'----------------------------------------------------------------------------------

SUB SetAttribute (BYVAL ColorToSet AS BYTE, BYVAL PtrBuf AS STRING PTR)



   LOCAL Counter AS LONG, PtrBuf2 AS STRING PTR



'----------------------------------------------------------------------------------
' Fill the Console Screen Buffer with the requested attributes
'----------------------------------------------------------------------------------

    PtrBuf2 = PtrBuf + 2

    FOR Counter = 1 TO 2000

        POKE PtrBuf2, ColorToSet
        PtrBuf2 = PtrBuf2 +  4

    NEXT Counter



END SUB


'-----------------------------------------------------------------------------------
' Prepare an attribute: InkColor on BackColor to insert into Screen Buffer
'-----------------------------------------------------------------------------------

SUB PrepareAttribute (BYVAL InkColor AS BYTE, BYVAL BackColor AS BYTE)

   #REGISTER NONE

'-----------------------------------------------------------------------------------
' Preparing attribute InkColor on BackColor. The Background color is multiplied by 16
'-----------------------------------------------------------------------------------

   !xor eax, eax
   !xor ebx, ebx
   !mov al, BackColor
   !shl eax, 4
   !mov bl, InkColor
   !add eax, ebx
   !mov ColorToSet, al


END SUB


'-----------------------------------------------------------------------------------
' Fill the remain of the Screen Buffer with the sequence of numbers and ASCII chars
'-----------------------------------------------------------------------------------

SUB DisplaySequence

    #REGISTER NONE

    LOCAL InitNum AS LONG, EndNum AS LONG, Row AS LONG, Col AS LONG
    LOCAL Counter AS LONG, Distance AS LONG, PtrBuf2 AS STRING PTR
    LOCAL AsciiCode AS STRING, PtrAsciiCode AS STRING PTR

    AsciiCode = SPACE$(4)
    PtrAsciiCode = STRPTR(AsciiCode)


'-----------------------------------------------------------------------------------
' Prepare the string to insert into the Screen Buffer with the ASCII chars
'-----------------------------------------------------------------------------------

    !mov ebx, PtrAsciiCode
    !mov eax, [ebx]
    !mov ah,  ColorToSet
    !shl eax, 8
    !mov [ebx], eax

'-----------------------------------------------------------------------------------
    PtrBuf = STRPTR(ScreenBuffer)
    PtrBuf2 = PtrBuf + (4 * 80 * 4) + 20


    FOR Row = 5 TO 24

        FOR Col = 6 TO 78 STEP 6

            PtrAsciiCode = STRPTR(AsciiCode)

            !mov ebx, PtrAsciiCode
            !mov eax, [ebx]
            !inc eax
            !mov [ebx], eax
            !mov ebx, PtrBuf2
            !mov [ebx], eax
            !cmp al, 255
            !je  EndCycle

            PtrBuf2 = PtrBuf2 + 24

        NEXT Col

        PtrBuf2 = PtrBuf2 + 8

    NEXT Row

EndCycle:


END SUB
